$('button#delete').click(function (e) {
    e.preventDefault()
    e.stopPropagation()

    var tr = $(this).closest('tr')
    var id = $(this).val()

    $.ajax({
        type: 'POST',
        url: 'http://' + window.location.host + '/api/diets/' + id + '/delete',
        context: document.body,
        timeout: 1000
    })
        .done(function (data) {
            logger.info(data._id + " " + "{{ strings.toastMessage.delete.success }}")
            toastr.success("{{ strings.toastMessage.delete.success }}", data.name)

            tr.animate(
                { 'line-height': 0 },
                150
            ).hide(1)
        })
        .fail(function (jqXHR, textStatus, errorThrown) {
            logger.error("{{ strings.toastMessage.delete.failure }}" + " : " + (jqXHR.responseJSON ? jqXHR.responseJSON.message : "{{ strings.general.error }}"))
            toastr.error((jqXHR.responseJSON ? jqXHR.responseJSON.message : "{{ strings.general.error }}"), "{{ strings.toastMessage.delete.failure }}")
        })
})


$('button#modify').click(function (e) {
    e.preventDefault()
    e.stopPropagation()

    $('#confirm').attr('val', $(this).attr('val'))
    $('#confirm').attr('id', 'update')

    var td = $(this).closest('td').prev()

    if (td.text().trim() !== "{{ strings.diets.noDescription }}" && td.text().trim() !== '') {
        $('#new-description').val(td.text().trim())
    } else {
        $('#new-description').val('')
    }

    $('#new-description').attr('placeholder', "{{ strings.diets.newDescription }}")

    td = td.prev()
    $('#new-name').val(td.text())
    $('#new-name').attr('placeholder', "{{ strings.diets.newName }}")

    $('#_id').val($(this).val())

    $('#button-validate').text('V')

    $('#new-name').focus()
})


$('button#confirm').click(function (e) {
    e.preventDefault()
    e.stopPropagation()

    if ($('#new-name').val() != '') {
        var data = {
            id: $('#_id').val(),
            name: $('#new-name').val().trim(),
            description: $('#new-description').val().trim()
        }


        // if not empty, it's an update
        if (data.id) {
            $.ajax({
                type: 'POST',
                data: JSON.stringify(data),
                contentType: 'application/json',
                url: 'http://' + window.location.host + '/api/diets/' + data.id + '/update',
                context: document.body,
                timeout: 1500
            })
                .done(function (data) {
                    logger.info(data._id + " " + "{{ strings.toastMessage.update.success }}" + " : " + data)
                    toastr.success("{{ strings.toastMessage.update.success }}", data.name)

                    var tr = $('button#modify[value="' + data._id + '"]').closest('tr')

                    tr.children('#name').html(data.name)
                    tr.children('#description').html((data.description ? data.description : "<span style=\"color: lightgrey\">" + "{{ strings.diets.noDescription }}" + "</span>"))

                    // reset inputs
                    $('#new-name').attr('placeholder', "{{ strings.general.name }}")
                    $('#new-name').val('')

                    $('#new-description').attr('placeholder', "{{ strings.general.description }}")
                    $('#new-description').val('')

                    $('#_id').val('')

                    $('#button-validate').text('+')
                })
                .fail(function (jqXHR, textStatus, errorThrown) {
                    logger.error("{{ strings.toastMessage.update.failure }}" + " : " + (jqXHR.responseJSON ? jqXHR.responseJSON.message : "{{ strings.general.error }}") + "\n" + JSON.stringify(data))
                    toastr.error((jqXHR.responseJSON ? jqXHR.responseJSON.message : "{{ strings.general.error }}"), "{{ strings.toastMessage.update.failure }}")
                })

            $('#_id').val('')

        } else {
            $.ajax({
                type: 'POST',
                data: JSON.stringify(data),
                contentType: 'application/json',
                url: 'http://' + window.location.host + '/api/diets/new',
                context: document.body,
                timeout: 1000
            })
                .done(function (data) {
                    logger.info(data._id + " " + "{{ strings.toastMessage.add.success }}" + " : " + JSON.stringify(data))
                    toastr.success("{{ strings.toastMessage.add.success }}", data.name)

                    $("table#table").attr('hidden', false)

                    var v = "<div id=\"\" class=\"btn btn-xs btn-success\" style=\"width: 30px padding: 0\">" +
                        "<span class=\"glyphicon glyphicon-ok\">V</span>" +
                        "</div>"


                    $("table#table > tbody:last-child").append(
                        "<tr>" +
                        "<td>" + data.name + "</td>" +
                        "<td>" + (data.description ? data.description : ("<span style=\"color: lightgrey\">" + "{{ strings.diets.noDescription }}") + "</span>") + "</td>" +
                        "<td>" + v + "</td>" +
                        "</tr>"
                    )

                    $('#_id').val('')
                })
                .fail(function (jqXHR, textStatus, errorThrown) {
                    logger.error("{{ strings.toastMessage.add.failure }}" + " : " + (jqXHR.responseJSON ? jqXHR.responseJSON.message : "{{ strings.general.error }}") + "\n" + JSON.stringify(data))
                    toastr.error((jqXHR.responseJSON ? jqXHR.responseJSON.message : "{{ strings.general.error }}"), "{{ strings.toastMessage.add.failure }}")
                })
        }

    } else {
        toastr.warning("{{ strings.toastMessage.warnings.missingField }}")
    }

})